<template>
  <div>
    <form @submit.prevent="submit">
      <input type="text" v-model="searchTerm" ref="searchTextBox" />
      <button type="submit">Search</button>
    </form>
    <div class="error" :style="{ opacity: errorOpacity }">
      Please provide a search term
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { EVENTS } from '@/utils/constants'
import { useSearchStore } from '@/stores/search'

const searchTextBox = ref(null)
const searchTerm = ref('')
const errorOpacity = ref(0)
const emit = defineEmits([EVENTS.SEARCH])
const searchStore = useSearchStore()

onMounted(() => {
  const searchElement = searchTextBox.value as HTMLElement | null
  searchElement?.focus()
})

const validateInput = (): boolean => {
  if (searchTerm.value) return true
  errorOpacity.value = 1
  setTimeout(() => {
    errorOpacity.value = 0
  }, 3000)
  return false
}

const submit = (): void => {
  if (validateInput()) {
    searchStore.searchTerm = searchTerm.value
    emit(EVENTS.SEARCH, searchTerm.value)
  }
}
</script>

<style scoped>
form {
  display: flex;
  justify-content: center;
}
input {
  width: 90%;
}
.error {
  color: tomato;
  transition: opacity 0.2s;
}
@media screen and (min-width: 960px) {
  input {
    width: 30%;
  }
}
</style>
